varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	lowp float smoothing = 2.0/16.0;
	lowp float distance = texture2D(u_texture, v_texCoord).a;
	lowp float border = smoothstep(0.5 - smoothing, 0.5 + smoothing, distance);
	gl_FragColor = vec4( v_color.rgb,  border * v_color.a);
}
