varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

void main() {
	float y = clamp(1.5 * v_texCoord.y, 0.0, 1.0);
	float gradientValue = mix(0.55, 0.25, y);

	vec4 reflectionColor = texture2D(u_texture1, v_texCoord);
	vec4 mainColor = texture2D(u_texture, v_texCoord);
	gradientValue = gradientValue + 0.95 * reflectionColor.g + mainColor.a;
	gl_FragColor = vec4(1.0, 1.0, 1.0, gradientValue);
}
