attribute highp vec4 a_position;
attribute highp vec4 a_color;
attribute highp vec2 a_texCoord;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform highp vec4 u_positionOffset;

varying highp vec4 v_color;
varying highp vec2 v_texCoord;

void main()
{
	
	vec4 offset_pos = a_position + (u_positionOffset * abs(a_position));
	gl_Position = u_modelViewProjectionMatrix * offset_pos;
	v_color = a_color;
	v_texCoord = a_texCoord;
	
}