varying mediump vec4 v_color;
varying mediump vec2 v_texCoord;

uniform vec4 u_materialAmbient;
uniform vec4 u_materialDiffuse;
uniform vec4 u_materialSpecular;

void main() {
	float yCoord = clamp(v_texCoord.y*2.0, 0.0, 1.0);
	gl_FragColor = mix(u_materialAmbient, u_materialDiffuse, yCoord);
	yCoord = clamp(v_texCoord.y*2.0 - 1.0, 0.0, 1.0);
	gl_FragColor = mix(gl_FragColor, u_materialSpecular, yCoord);
	gl_FragColor = gl_FragColor * v_color;
}