varying lowp vec2 v_texCoord;
varying highp vec4 v_color;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;
uniform lowp vec4 tint_t0;
uniform lowp vec4 tint_t1;

varying highp vec2 scrollUV0;
varying highp vec2 scrollUV1;

void main()
{
	float alpha_0 = texture2D(u_texture, scrollUV0).r * v_color.a;
	float alpha_1 = texture2D(u_texture, scrollUV1).g * v_color.a;

	gl_FragColor = (tint_t0 * alpha_0) + (tint_t1 * alpha_1);
}