local function InternalOnLinkCancelled()
	local currentValue = tonumber(API_GetConfigurationAttribute("cancellingTutorialCounter","0"))
	local newValue = currentValue + 1
	API_SetConfigurationAttribute("cancellingTutorialCounter",tostring(newValue))
end

local function InternalOnStart()
	if API_GetConfigurationAttribute("cancellingTutorialCounter","0") < "1" then
		API_Log("DYNAMIC TUTOR: CANCELLING COUNTER")
		RegisterOnLinkCancelledCallback(InternalOnLinkCancelled)
	end
end

RegisterOnStartCallback(InternalOnStart)