theGameAPI = {}
local COROUTINES_WAITING_TURN_COUNT_DOWN = {}
local mainCoroutine = coroutine.running()

TRUE = 1
FALSE = 0

-- common variables for all scripts

-- defined variables for layout positioning


setAPI = function(gravityAPI)
	theGameAPI = gravityAPI;
end

function API_GetTutorialShownCount(tutorialName)
	return theGameAPI:LuaCallsToGame("GetTutorialShownCount", tutorialName, "", "", "", "", "", "")
end

function API_IncrementTutorialShownCount(tutorialName)
	return theGameAPI:LuaCallsToGame("IncrementTutorialShownCount", tutorialName, "", "", "", "", "", "")
end

function API_EnableCheckBoardStable(enabled)
	return theGameAPI:LuaCallsToGame("EnableCheckBoardStable", enabled, "", "", "", "", "", "")
end

function API_EnableCheckDiamondMovement(enabled)
	return theGameAPI:LuaCallsToGame("EnableCheckDiamondMovement", enabled, "", "", "", "", "", "")
end

function API_GetItemHealth(itemTag)
	return theGameAPI:LuaCallsToGame("GetItemHealth", itemTag, "", "", "", "", "", "")
end

function API_ExistsLink(linkType)
	return theGameAPI:LuaCallsToGame("ExistsLink", linkType, "", "", "", "", "", "")
end

function API_CountItemsByType(itemsType)
	return theGameAPI:LuaCallsToGame("CountItemsByType", itemsType, "", "", "", "", "", "")
end

function API_SetSagaMapStateMachineEnabled(enabled)
	return theGameAPI:LuaCallsToGame("SetSagaMapStateMachineEnabled", enabled, "", "", "", "", "", "")
end

function API_HasTutorialBeenTriggered(tutorialName)
	return theGameAPI:LuaCallsToGame("HasTutorialBeenTriggered", tutorialName, "", "", "", "", "", "")
end

function API_SetTutorialAsTriggered(tutorialName, isTriggered)
	return theGameAPI:LuaCallsToGame("SetTutorialAsTriggered", tutorialName, isTriggered, "", "", "", "", "")
end

function API_SetElementsVisibility(className, visibility)
	return theGameAPI:LuaCallsToGame("SetElementsVisibility", className, visibility, "", "", "", "", "")
end

function API_BringToFront(className)
	return theGameAPI:LuaCallsToGame("BringToFront", className, "", "", "", "", "", "")
end

function API_SendToBack(className)
	return theGameAPI:LuaCallsToGame("SendToBack", className, "", "", "", "", "", "")
end

function API_SetInputAllowed(inputAllowed)
	return theGameAPI:LuaCallsToGame("SetInputAllowed", inputAllowed, "", "", "", "", "", "")
end

function API_SetScrollingEnabledByClass(scrollerClass, enabled)
	return theGameAPI:LuaCallsToGame("SetScrollerBlockedByName", scrollerClass, enabled, "", "", "", "", "")
end

function API_EnableGravityArea(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableGravityArea", objectID, "", "", "", "", "", ""))
end

function API_DisableGravityArea(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("DisableGravityArea", objectID, "", "", "", "", "", ""))
end

function API_SetGravityAreaDirection(tagId, x, y)
	return theGameAPI:LuaCallsToGame("SetGravityAreaDirection", tagId, x, y, "", "", "", "")
end

function API_SetGravityAreaIntensity(tagId, intensity)
	return theGameAPI:LuaCallsToGame("SetGravityAreaIntensity", tagId, intensity, "", "", "", "", "")
end

function API_SetFluidAreaLevel(id, percent)
	return theGameAPI:LuaCallsToGame("SetFluidAreaLevel", id, percent, "", "", "", "", "")
end

function API_SetFluidAreaBottleLevel(id, bottlePercent)
	return theGameAPI:LuaCallsToGame("SetFluidAreaBottleLevel", id, bottlePercent, "", "", "", "", "")
end

function API_TranslateFluidAreaInPixels(id, x, y)
	return theGameAPI:LuaCallsToGame("TranslateFluidAreaInPixels", id, x, y, "", "", "", "")
end

function API_AllowInputOn(className)
	return theGameAPI:LuaCallsToGame("AllowInputOn", className, "", "", "", "", "", "")
end

function API_HideAllImages()
	return theGameAPI:LuaCallsToGame("HideAllImages", "", "", "", "", "", "", "")
end

function API_ShowImage(imageClass, relPosX, relPosY, flipX, flipY, textKey)
	return theGameAPI:LuaCallsToGame("ShowImage", imageClass, relPosX, relPosY, flipX, flipY, textKey, "")
end

function API_ShowImageAtComponent(imageClass, componentName, relPosX, relPosY, flipX, flipY, textKey)
	return theGameAPI:LuaCallsToGame("ShowImageAtComponent", imageClass, componentName, relPosX, relPosY, flipX, flipY, textKey)
end

function API_ShowImageAtItem(imageClass, tag)
	return theGameAPI:LuaCallsToGame("ShowImageAtItem", imageClass, tag, "", "", "", "", "")
end

function API_ShowDarkOverlay(overScrollers)
	return theGameAPI:LuaCallsToGame("ShowDarkOverlay", overScrollers, "", "", "", "", "", "")
end

function API_HideDarkOverlay()
	return theGameAPI:LuaCallsToGame("HideDarkOverlay", "", "", "", "", "", "", "")
end

function API_ShowPopup(templateName, verticalPosition, titleKey, bodyKey, buttonLabelKey, imageClass)
	return theGameAPI:LuaCallsToGame("ShowPopup", templateName, verticalPosition, titleKey, bodyKey, buttonLabelKey, imageClass, "")
end

function API_HidePopup()
	return theGameAPI:LuaCallsToGame("HidePopup", "", "", "", "", "", "", "")
end

function API_ToHash(string)
	return  theGameAPI:LuaCallsToGame("ToHash", string, "", "", "", "", "", "")
end

function API_AddTemporalBooster(boosterType, amount)
	return  theGameAPI:LuaCallsToGame("AddTemporalBooster", boosterType, amount, "", "", "", "", "")
end

function API_EnableGameModeGoal(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableGameModeGoal", objectID, "", "", "", "", "", ""))
end

function API_DisableGameModeGoal(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("DisableGameModeGoal", objectID, "", "", "", "", "", ""))
end

function API_EnableTrigger(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableTrigger", objectID, "", "", "", "", "", ""))
end

function API_DisableTrigger(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("DisableTrigger", objectID, "", "", "", "", "", ""))
end

function API_SwitchViewport(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SwitchViewport", objectID, "", "", "", "", "", ""))
end

function API_SetRailId(objectID, railID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetRailId", objectID, railID, "", "", "", "", ""))
end

function API_Log(message)
	return  as3.tolua(theGameAPI:LuaCallsToGame("Log", message, "", "", "", "", "", ""))
end

function API_TouchElement(className)
	return  as3.tolua(theGameAPI:LuaCallsToGame("TouchElement", className, "", "", "", "", "", ""))
end

function API_PlaySound(soundName)
	return  as3.tolua(theGameAPI:LuaCallsToGame("PlaySound", soundName, "", "", "", "", "", ""))
end

function API_AddDynamicTutorial(tutorialFileName)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddDynamicTutorial", tutorialFileName, "", "", "", "", "", ""))
end

function API_PlayDynamicTutorial(tooltipName, tooltipPiecesColorName, cheeringTextName, cheeringPieceColorName)
	return  as3.tolua(theGameAPI:LuaCallsToGame("PlayDynamicTutorial", tooltipName, tooltipPiecesColorName, cheeringTextName, cheeringPieceColorName, "", "", ""))
end

function API_PlayDynamicTutorialHint(hintName, withCloseButton)
	return  as3.tolua(theGameAPI:LuaCallsToGame("PlayDynamicTutorialHint", hintName, withCloseButton, "", "", "", "", ""))
end

function API_StartTutorial(validInputType)
	return  as3.tolua(theGameAPI:LuaCallsToGame("StartTutorial", validInputType, "", "", "", "", "", ""))
end

function API_ShowTutorialPopup(validInputType, textID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowTutorialPopup", validInputType, textID, "", "", "", "", ""))
end

function API_EndTutorial()
	return  as3.tolua(theGameAPI:LuaCallsToGame("EndTutorial", "", "", "", "", "", "", ""))
end

function API_WaitForTutorialLink(itemTags, matchType, lightFactor) -- Deprecated; use version without lightFactor
	return as3.tolua(theGameAPI:LuaCallsToGame("WaitForTutorialLink", itemTags, matchType, lightFactor, "", "", "", ""))
end

function API_WaitForTutorialLink(itemTags, matchType)
	return as3.tolua(theGameAPI:LuaCallsToGame("WaitForTutorialLink", itemTags, matchType, "", "", "", "", ""))
end

function API_PlayTimeline(timelineName, sceneObjectName, useOriginalSceneObject)
	return  as3.tolua(theGameAPI:LuaCallsToGame("PlayTimeline", timelineName, sceneObjectName, useOriginalSceneObject, "", "", "", ""))
end

function API_StopCurrentTimeline()
	return  as3.tolua(theGameAPI:LuaCallsToGame("StopCurrentTimeline", "", "", "", "", "", "", ""))
end

function API_EnableAllItems()
	return as3.tolua(theGameAPI:LuaCallsToGame("EnableAllItems", "", "", "", "", "", "", ""))
end

function API_EnableTaggedItems(itemTags)
	return as3.tolua(theGameAPI:LuaCallsToGame("EnableTaggedItems", itemTags, "", "", "", "", "", ""))
end

function API_DisableTaggedItems(itemTags, lightFactor) -- Deprecated; use version without light factor
	return as3.tolua(theGameAPI:LuaCallsToGame("DisableTaggedItems", itemTags, lightFactor, "", "", "", "", ""))
end

function API_DisableTaggedItems(itemTags)
	return as3.tolua(theGameAPI:LuaCallsToGame("DisableTaggedItems", itemTags, "", "", "", "", "", ""))
end

function API_SetTutorialTextBodyAndHeightPercent(textIdToShow, heightPercent)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetTextBody", textIdToShow, heightPercent, "", "", "", "", ""))
end

function API_RemoveTutorialTextBody()
	return  as3.tolua(theGameAPI:LuaCallsToGame("RemoveTextBody", "", "", "", "", "", "", ""))
end

function API_SetTutorialTextBody(textIdToShow)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetTextBody", textIdToShow, "", "", "", "", "", ""))
end

function API_SetTutorialImage(xmlFileToLoad)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetImageSceneObject", xmlFileToLoad, "", "", "", "", "", ""))
end

function API_SetCharacterDialog(characterName, textId, buttonTextId)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetCharacterDialog", characterName, textId, buttonTextId, "", "", "", ""))
end

function API_AddInputFilterArea(topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddInputFilterArea", topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY, "", "", ""))
end

function API_ShowFingerAnimation(itemTags, timeInMiliseconds)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerAnimation", itemTags, timeInMiliseconds, "", "", "", "", ""))
end

function API_SetNextPowerupColor(color)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetNextPowerupColor", color, "", "", "", "", "", ""))
end

function API_ShowArrowAnimation(fromTileX, fromTileY, toTileX, toTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowArrowAnimation", fromTileX, fromTileY, toTileX, toTileY, "", "", ""))
end

function API_ShowFingerTapAnimation(tileX, tileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerTapAnimation", tileX, tileY, "", "", "", "", ""))
end

function API_ShowFingerBoosterTapAnimation(tileX, tileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowFingerBoosterTapAnimation", tileX, tileY, "", "", "", "", ""))
end

function API_EnableGlobalMasking(enable)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableGlobalMasking", enable, "", "", "", "", "", ""))
end

function API_EnableInputMask(enable, id)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableInputMask", enable, id, "", "", "", "", ""))
end

function API_SetAllowedLinking(linkingAllowed)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetAllowedLinking", linkingAllowed, "", "", "", "", "", ""))
end

function API_EnqueueRotate(objectID, angle, duration)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnqueueRotate", objectID, angle, duration, "", "", "", ""))
end

function API_EnqueueTranslate(objectID, xDisplacement, yDisplacement, duration)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnqueueTranslate", objectID, xDisplacement, yDisplacement, duration, "", "", ""))
end

function API_FlushTransformations()
	return  as3.tolua(theGameAPI:LuaCallsToGame("FlushTransformations", "", "", "", "", "", "", ""))
end

function API_Rotate(objectID, angle, duration)
	API_EnqueueRotate(objectID, angle, duration)	
	return  API_FlushTransformations()
end

function API_Translate(objectID, xDisplacement, yDisplacement, duration)
	API_EnqueueTranslate(objectID, xDisplacement, yDisplacement, duration)	
	return  API_FlushTransformations()
end

function API_EnableSpawner(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableSpawner", objectID, "", "", "", "", "", ""))
end

function API_DisableSpawner(objectID)
	return  as3.tolua(theGameAPI:LuaCallsToGame("DisableSpawner", objectID, "", "", "", "", "", ""))
end

function API_SetSpawnerItemColorWeight(objectID, color, weight)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnerItemColorWeight", objectID, color, weight, "", "", "", ""))
end

function API_SetSpawnerTypeWeight(objectID, itemType, weight)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnerTypeWeight", objectID, itemType, weight, "", "", "", ""))
end

function API_SetSpawnerPowerupColorWeight(objectID, powerupType, color, weight)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnerPowerupColorWeight", objectID, powerupType, color, weight, "", "", ""))
end

function API_SetSpawnerHealthWeight(objectID, itemType, health, weight)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnerHealthWeight", objectID, itemType, health, weight, "", "", ""))
end

function API_SetSpawnForce(objectID, intensity, angle)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnForce", objectID, intensity, angle, "", "", "", ""))
end

function API_SetSpawnAreaRadius(objectID, radius)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnAreaRadius", objectID, radius, "", "", "", "", ""))
end

function API_SetSpawnAreaOffset(objectID, offsetX, offsetY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetSpawnAreaOffset", objectID, offsetX, offsetY, "", "", "", ""))
end

function API_SetItemSpawnInterval(objectID, itemType, health, spawnInterval)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetItemSpawnInterval", objectID, itemType, health, spawnInterval, "", "", ""))
end

function API_SetItemsCreatedPerSpawn(objectID, itemType, health, numPerSpawn)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetItemsCreatedPerSpawn", objectID, itemType, health, numPerSpawn, "", "", ""))
end

function API_ResetItemSpawnIntervalTurnCounter(objectID, itemType, health)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ResetItemSpawnIntervalTurnCounter", objectID, itemType, health, "", "", "", ""))
end

--Adds a booster that will only be available during the current level
function API_AddTemporalBooster(booserType, amount)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddTemporalBooster", booserType, amount, "", "", "", "", ""))
end

function API_EnableButton(enable, sceneObjectName)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableButton", enable, sceneObjectName, "", "", "", "", ""))
end

--Possible values for zLayer: "top", "ui", "active_powerup", "board_foreground", "tile_blocker", "item_over_water", "tile_foam", "item_water_line", "item_under_water", "tile_background")
function API_SetGameplayScreenSceneObjectZ(sceneObjectName, zLayer)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetGameplayScreenSceneObjectZ", sceneObjectName, zLayer, "", "", "", "", ""))
end

function API_ShowGameplayScreenSceneObject(sceneObjectName, visible)
	return  as3.tolua(theGameAPI:LuaCallsToGame("ShowGameplayScreenSceneObject", sceneObjectName, visible, "", "", "", "", ""))
end

function API_EnableMaskTiles(enable, topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableMaskTiles", enable, topLeftTileX, topLeftTileY, bottomRightTileX, bottomRightTileY, "", ""))
end

function API_HighlightItems(tilesList)
	API_Log("Entering in API_HighlightItems")
	return as3.tolua(theGameAPI:LuaCallsToGame("HighlightItems", tilesList, "", "", "", "", "", ""))
end

function API_SetPositionRelativeToObject(objectName, objectNameAnchor, x, y)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetPositionRelativeToObject", objectName, objectNameAnchor, x, y, "", "", ""))
end

function API_SetPositionRelativeToBoardTile(objectName, xTile, yTile, xOffset, yOffset)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetPositionRelativeToBoardTile", objectName, xTile, yTile, xOffset, yOffset, "", ""))
end

function API_EnableHint(enable)
	return  as3.tolua(theGameAPI:LuaCallsToGame("EnableHint", enable, "", "", "", "", "", ""))
end

function API_AddItemsToSpawnerBuffer(itemsList)
	return  as3.tolua(theGameAPI:LuaCallsToGame("AddItemsToSpawnerBuffer", itemsList, "","","","","",""))
end

function API_ClearSpawnerBuffer()
	return  as3.tolua(theGameAPI:LuaCallsToGame("ClearSpawnerBuffer", "","","","","","",""))
end

-- if parent is "" it will be attached to the rootsceneobject.
function API_LoadArbitraryXML(xmlFileToLoad,parentToAttachTo)
	return  as3.tolua(theGameAPI:LuaCallsToGame("LoadArbitrarySceneObject", xmlFileToLoad,parentToAttachTo,"","","","",""))
end

-- call this to clear the things loaded with API_LoadArbitraryXML
function API_RemoveArbitraryXML()
	return  as3.tolua(theGameAPI:LuaCallsToGame("RemoveAllArbitrarySceneObjects", "", "","","","","",""))
end

function API_CallFunctionAfterDelay(functionName, param1, secondsToWait)
	as3.tolua(theGameAPI:LuaCallsToGame("CallLuaFunctionAfterDelay", functionName, param1, secondsToWait, "", "", "", ""))
end

function API_SetConfigurationAttribute(attributeName, attributeValue)
	return as3.tolua(theGameAPI:LuaCallsToGame("SetConfigurationAttribute", attributeName, attributeValue, "", "", "", "", ""))
end

function API_GetConfigurationAttribute(attributeName, attributeDefaultValue)
	return as3.tolua(theGameAPI:LuaCallsToGame("GetConfigurationAttribute", attributeName, attributeDefaultValue, "", "", "", "", ""))
end

function API_SetCreationOfPowerUp(powerupType, isActive)
	return as3.tolua(theGameAPI:LuaCallsToGame("SetCreationOfPowerUp", powerupType, isActive, "", "", "", "", ""))
end

function API_SetPowerupCreationWeight(powerupColor, weight)
	return as3.tolua(theGameAPI:LuaCallsToGame("SetPowerupCreationWeight", powerupColor, weight, "", "", "", "", ""))
end

function API_NotifyCompletedPowerupTutorial(powerupType)
	return as3.tolua(theGameAPI:LuaCallsToGame("NotifyCompletedPowerupTutorial", powerupType, "", "", "", "", "", ""))
end

function API_SetHummingbirdTouchTheLineProperties(distance, angle)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetHummingbirdTouchTheLineProperties", distance, angle, "", "", "", "", ""))
end

function API_CheckHammerPreviewOverlay(objectId)
	API_Log("*** API_CheckHammerPreviewOverlay")
	return  as3.tolua(theGameAPI:LuaCallsToGame("CheckHammerPreviewOverlay", objectId, "", "", "", "", "", ""))
end

function API_SetUnlimitedBoosters(boosterType, value)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SetUnlimitedBoosters", boosterType, value, "", "", "", "", ""))
end

function API_StopFingerAnimation()
	return  as3.tolua(theGameAPI:LuaCallsToGame("StopFingerAnimation", "", "", "", "", "", "", ""))
end

function API_SeedBooster(boosterType, amount)
	return  as3.tolua(theGameAPI:LuaCallsToGame("SeedBooster", boosterType, amount, "", "", "", "", ""))
end

function API_DeleteItemsInSpecifiedArea(tagId)
	return theGameAPI:LuaCallsToGame("DeleteItemsInSpecifiedArea", tagId, "", "", "", "", "", "")
end

--------------------------------------------------------------------------------------------------------
-- UTILITIES
function API_BlockInputEverywhereBut(buttonClassName)
	API_Log("*** API_BlockInputEverywhereBut")
	API_SetInputAllowed("false")	
	API_AllowInputOn(buttonClassName)
end

function API_DarkScreenBut(buttonClassName)
	API_Log("*** API_DarkScreenBut")
	API_ShowDarkOverlay("false")
	API_BlockInputEverywhereBut(buttonClassName)
	API_BringToFront(buttonClassName)
end

--------------------------------------------------------------------------------------------------------
-- THREAD MANAGEMENT

function API_StartThread(funct)
	co = coroutine.create(funct)
	coroutine.resume(co)
end
-- pause current thread and wait n turns to wake it up
function API_WaitNTurns(numberOfTurnsToWait)
	local co = coroutine.running() -- get current thread
	if co == nil or co == mainCoroutine then
		API_Log("*******************************************************************************************")
		API_Log("*******************************************************************************************")
		API_Log("INVALID THREAD, CALL API_StartThread TO START A NEW THREAD TO BE ABLE TO USE API_WaitNTurns")
		API_Log("*******************************************************************************************")
		API_Log("*******************************************************************************************")
		return
	end
	COROUTINES_WAITING_TURN_COUNT_DOWN[co] = numberOfTurnsToWait
	return coroutine.yield() -- pause the thread
end

-- count down the turns (this function must be called each OnEndTurn by C++/AS code)
-- and wake up the threads whrn the count down is done
function INTERNAL_WakeUpWaitingThreadsByTurnCountDown()

	local threadsToWake = {}
	for co, turnsCountDown in pairs(COROUTINES_WAITING_TURN_COUNT_DOWN) do
		turnsCountDown = turnsCountDown - 1
		if turnsCountDown <= 0 then
			table.insert(threadsToWake, co)
			COROUTINES_WAITING_TURN_COUNT_DOWN[co] = nil
		else 
			COROUTINES_WAITING_TURN_COUNT_DOWN[co] = turnsCountDown
		end
	end

	for _, co in ipairs(threadsToWake) do
		coroutine.resume(co)
	end
end

function API_StringToBool(stringValue)
	if stringValue == "true" then
		return true
	else
		return false
	end
end
