function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
end



function onTutorialInitialized()
	LinkRedInAnyOrder()
end



function LinkRedInAnyOrder()
	API_Log("*** Link red in any order")
	API_SetTutorialTextBody("tutorial_linking")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("9,10,11", "any_order", "0.3")
	API_ShowFingerAnimation("9,10,11", 1);
end



function LinkGreenAnyOrder()
	API_Log("*** Link green in any order")
	API_SetTutorialTextBody("tutorial_touch_the_line")
	API_SetAllowedLinking("true")
	API_EnableAllItems()
	API_WaitForTutorialLink("3,4,5", "any_order", "0.3")
	API_ShowFingerAnimation("3,4,5", 1);
	API_EnableTaggedItems("8");
end



function OpenTheGates ()
	API_Translate(6, -200, -240, 0.5)
	API_Translate(7, 200, -240, 0.5)
end



function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_CallFunctionAfterDelay("LinkGreenAnyOrder", 0, 2)
		API_SetAllowedLinking("false")
		OpenTheGates ()
	elseif tutorialStep == 1 then
		API_EndTutorial()
	end
end
