function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
end



function onTutorialInitialized()
	if tutorialStep == 0 then
		LinkRay()
	elseif tutorialStep == 1 then
		CreateRay()
	end
end



function LinkRay()
	API_Log("*** Link ray")
	API_SetTutorialTextBody("tutorial_ray_trigger")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("0,1,2", "any_order", "0.3")
	API_ShowFingerAnimation("0,1,2", 1);
end



function CreateRay()
	API_Log("*** Create ray")
	API_SetTutorialTextBody("tutorial_ray_creation")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("3,4,5,6,7,8", "any_order", "0.3")
	API_ShowFingerAnimation("3,4,5,6,7,8,7,6,5", 1.5);
end



function onBoardChanged()
	API_Log("**************onBoardChanged")
	API_StartTutorial("interactive")
end



function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_EndTutorial()
	elseif tutorialStep == 1 then
		API_EndTutorial()
	end
end
