
function onInit()
	API_Log("**************onInit")
end

function onGameRoundStart()
	API_Log("**************onGameRoundStart")
	incrementalNumber = 0
	isAnimating = false
end

function onItemsLinked()
	API_Log("**************onItemsLinked")
	incrementalNumber = incrementalNumber + 1
end

function onRotationEnd(objectID)
	API_Log("**************onRotationEnd: " .. objectID)
end

function onTranslationEnd(objectID)
	API_Log("**************onTranslationEnd: " .. objectID)
	isAnimating = false
end

function onFeederLinked(objectID, hydraLevel)
	API_Log("**************onFeederLinked: " .. objectID .. " " .. hydraLevel)
end

function onHydraLinked(objectID, hydraLevel)
	API_Log("**************onHydraLinked: " .. objectID .. " " .. hydraLevel)
end

function onHydraCollected(objectID)
	API_Log("**************onHydraCollected: " .. objectID)
end

function onDiamondCollected(objectID)
	API_Log("**************onDiamondCollected: " .. objectID)
end

function onLockOpened(objectID)
	API_Log("**************onLockOpened: " .. objectID)
end