function onTutorialInitialized()
	if tutorialStep == 0 then
		API_SetTutorialImage("art/scenes/animated_tutorial/tutorial_feeder_link.xml")
		API_SetTutorialTextBody("tutorial_feeder")
	elseif tutorialStep == 1 then
		API_SetTutorialImage("art/scenes/animated_tutorial/tutorial_feeder_pu.xml")
		API_SetTutorialTextBody("tutorial_feeder_pu")
	end
end

function LinkStep0()
	API_Log("**************step0")
    API_StartTutorial("interactive")
end

function LinkStep1()
	API_Log("**************step1")
	API_StartTutorial("interactive")
end

function onItemsLinked()
	API_Log("**************onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = -1
		API_EndTutorial();
	elseif tutorialStep == 1 then
		tutorialStep = 2
		API_EndTutorial()
	end
end

function onBoardChanged()
	API_Log("**************onBoardChanged")
	if tutorialStep == -1 then
		tutorialStep = 1
		LinkStep1()
	end
end

function onInit()
	API_Log("**************onInit")
	tutorialStep = 0
	LinkStep0()
end
