function onTutorialInitialized()
	API_SetTutorialImage("art/scenes/animated_tutorial/tutorial_linking.xml")
	API_SetTutorialTextBodyAndHeightPercent("tutorial_linking", 0.2)
end

function LinkStep1()
	API_Log("**************step1")
	API_SetTutorialImage("art/scenes/animated_tutorial/tutorial_touch_the_line.xml")
	API_SetTutorialTextBodyAndHeightPercent("tutorial_touch_the_line", 0.8)
	API_SetAllowedLinking("true")
end

function onItemsLinked()
	API_Log("**************onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_CallFunctionAfterDelay("LinkStep1", 0, 2)
		API_SetAllowedLinking("false")
	elseif tutorialStep == 1 then
		API_EndTutorial()
	end
end

function onInit()
	API_Log("**************onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
end
