varying lowp vec2 v_texCoord;
varying lowp vec4 v_color;

uniform highp float u_time;
uniform sampler2D u_texture;

void main()
{
	mediump vec4 texColor = texture2D(u_texture, v_texCoord);
	mediump float erosion = texture2D(u_texture, v_texCoord).r;
	mediump float alpha = clamp((erosion-(1.0-v_color.a))*texture2D(u_texture, v_texCoord).a*8.0,0.0,1.0);
	gl_FragColor = vec4(v_color.r, v_color.g, v_color.b, alpha);
}