varying highp vec2 v_texCoord;
varying lowp vec4 v_color;

uniform sampler2D u_texture;
uniform sampler2D u_texture1;

void main()
{
	vec4 color = texture2D(u_texture, v_texCoord);
	vec4 blur = texture2D(u_texture1, v_texCoord);
	vec4 colorNoAlpha = vec4(v_color.rgb, 1.0);
	gl_FragColor = mix(color, blur * colorNoAlpha, v_color.a);
}