varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	vec4 texColor = texture2D(u_texture, v_texCoord);
	vec4 finalcolor = vec4 (vec3 (texColor.rgb/(texColor.a + 0.0001)), texColor.a);
	gl_FragColor = v_color * finalcolor;
}