varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;

uniform sampler2D u_texture;

void main() {
	mediump float thickness = 0.53;
	mediump float smoothing = 0.5/16.0;
	mediump float distance = texture2D(u_texture, v_texCoord).a;
	mediump float border = smoothstep(thickness - smoothing, thickness + smoothing, distance);
	gl_FragColor = vec4( v_color.rgb,  border * v_color.a);
}
