function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
end



function onTutorialInitialized()
	if tutorialStep == 0 then
		LinkFeeder()
	elseif tutorialStep == 1 then
		HitFeederWithPu()
	end
end



function LinkFeeder()
	API_Log("*** Link Feeder")
	API_SetTutorialTextBody("tutorial_feeder")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("0,1,2,3,4,5", "any_order", "0.3")
	API_ShowFingerAnimation("0,1,2,4,3,5", 1);
end



function HitFeederWithPu()
	API_Log("*** Hit Feeder with PU")
	API_SetTutorialTextBody("tutorial_feeder_pu")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("6,7,8", "any_order_match_last", "0.3")
	API_ShowFingerAnimation("6,7,8", 1)
	API_EnableTaggedItems("9");
end



function onBoardChanged()
	API_Log("**************onBoardChanged")
	API_StartTutorial("interactive")
end



function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_EndTutorial()
	elseif tutorialStep == 1 then
		API_EndTutorial()
	end
end
