function onInit()
	API_Log("*** onInit")
	tutorialStep = 0
	API_StartTutorial("interactive")
	API_SetAllowedLinking("false")
end



function onTutorialInitialized()
	if tutorialStep == 0 then
		CollectHydra()
	elseif tutorialStep == 1 then
		SplitHydra()
	end
end



function CollectHydra()
	API_Log("*** Collect Hydra")
	API_SetTutorialTextBody("tutorial_hydra_link")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("0,1,2", "any_order", "0.3")
	API_ShowFingerAnimation("0,1,2", 1);
	API_EnableTaggedItems("6,7");
end



function SplitHydra()
	API_Log("*** Split Hydra")
	API_SetTutorialTextBody("tutorial_hydra_split")
	API_SetAllowedLinking("true")
	API_WaitForTutorialLink("3,4,5", "any_order", "0.3")
	API_ShowFingerAnimation("3,4,5", 1);
end



function onBoardChanged()
	API_Log("**************onBoardChanged")
	API_StartTutorial("interactive")
end



function onItemsLinked()
	API_Log("*** interactive linking: onItemsLinked")
	if tutorialStep == 0 then
		tutorialStep = 1
		API_EndTutorial()
	elseif tutorialStep == 1 then
		API_EndTutorial()
	end
end
