
function onInit()
	API_Log("**************onInit")
end

function onGameRoundStart()
	API_Log("**************onGameRoundStart")
	incrementalNumber = 0
	isAnimating = false
end

function onItemsLinked()
	API_Log("**************onItemsLinked")
	if isAnimating == false then
		isAnimating = true
		if incrementalNumber % 2 == 0 then
			API_Translate(0, 0, -700, 0.5)
			API_Translate(1, 700, 0, 0.5)
			API_Translate(2, 300, 0, 0.5)
			API_Translate(3, 0, -700, 0.5)
		else
			API_Translate(0, 0, 700, 0.5)
			API_Translate(1, -700, -10, 0.5)
			API_Translate(2, -300, 0, 0.5)
			API_Translate(3, 0, 700, 0.5)
		end
	end
	incrementalNumber = incrementalNumber + 1
end

function onRotationEnd(objectID)
	API_Log("**************onRotationEnd: " .. objectID)
end

function onTranslationEnd(objectID)
	API_Log("**************onTranslationEnd: " .. objectID)
	isAnimating = false
end