
function onInit()
	API_Log("**************onInit")
end

function onGameRoundStart()
	API_Log("**************onGameRoundStart")
	movementCounter = 0
	isMoving = false
	boardIndex = 0
end

function onItemsLinked()
	
	API_Log("**************onItemsLinked" .. boardIndex)
	if isMoving == false then
		isMoving = true
		if boardIndex == 0 then moveObstaclesOnBoard0() end
		if boardIndex > 0 then moveObstaclesOnBoard1() end
	end
end

function onBoardChanged()
	movementCounter = 0
	boardIndex = boardIndex + 1
	isMoving = false
end

function onRotationEnd(objectID)
	API_Log("**************onRotationEnd: " .. objectID)
	isMoving = false
end

function onTranslationEnd(objectID)
	API_Log("**************onTranslationEnd: " .. objectID)
	isMoving = false
end

function moveObstaclesOnBoard0()
	API_Log("**************moveObstaclesOnBoard0" .. movementCounter)
	if movementCounter == 0 then
		API_Translate(0, 200, 0, 1)
	elseif movementCounter == 1 then 
		API_Translate(0, -200, 0, 1)
	end
	movementCounter = movementCounter + 1
	movementCounter = movementCounter % 2
end

function moveObstaclesOnBoard1()
	API_Log("**************moveObstaclesOnBoard1" .. movementCounter)
	if movementCounter == 0 then
		API_Translate(1, 0, 240, 1)
	elseif movementCounter == 1 then 
		API_Translate(1, 0, -240, 1)
	end
	movementCounter = movementCounter + 1
	movementCounter = movementCounter % 2
end