
function onInit()
	API_Log("**************onInit")
end

function onGameRoundStart()
	API_Log("**************onGameRoundStart")
	incrementalNumber = 0
	isAnimating = false
end

function onItemsLinked()
	API_Log("**************onItemsLinked")
	if isAnimating == false then
		isAnimating = true
		if incrementalNumber % 2 == 0 then
			API_Translate(0, 500, 0, 0.5)
			API_Translate(1, 700, 0, 0.5)
			API_Translate(2, -700, 0, 0.5)
			API_Translate(3, -700, 0, 0.5)			
		else
			API_Translate(0, -500, 0, 0.5)
			API_Translate(1, -700, 0, 0.5)
			API_Translate(2, 700, 0, 0.5)
			API_Translate(3, 700, 0, 0.5)
		end
	end
	incrementalNumber = incrementalNumber + 1
end

function onRotationEnd(objectID)
	API_Log("**************onRotationEnd: " .. objectID)
end

function onTranslationEnd(objectID)
	API_Log("**************onTranslationEnd: " .. objectID)
	isAnimating = false
end

function onHydraLinked(objectID, hydraLevel)
	API_Log("**************onHydraLinked: " .. objectID .. " " .. hydraLevel)
end

function onHydraCollected(objectID)
	API_Log("**************onHydraCollected: " .. objectID)
end

function onDiamondCollected(objectID)
	API_Log("**************onDiamondCollected: " .. objectID)
end

function onLockOpened(objectID)
	API_Log("**************onLockOpened: " .. objectID)
end